import { PropsWithChildren, AllHTMLAttributes } from 'react';
import { BlockTagType } from './store';
export interface BlockProps<T extends BlockTagType> extends AllHTMLAttributes<T> {
    keyname?: string;
    /**
     * @deprecated use `keyname`
     */
    name?: string;
    /** Can be shown or hidden with controls */
    visible?: boolean;
    /** "index" refers to the use of indexes to control the order of controls, which can provide more flexible API encapsulation. */
    index?: number;
    /** custom created element */
    tagName?: T;
}
export declare const Block: import("react").MemoExoticComponent<(<Tag extends BlockTagType = "div">(props: PropsWithChildren<Partial<BlockProps<Tag>>>) => null)>;
