import React, { FC, PropsWithChildren } from 'react';
export interface TextareaProps extends React.InputHTMLAttributes<HTMLTextAreaElement> {
    keyname?: string;
    /**
     * Used to define the name of form controls
     * @deprecated use `name`
     */
    rename?: string;
    /** Can be shown or hidden with controls */
    visible?: boolean;
    /** "index" refers to the use of indexes to control the order of controls, which can provide more flexible API encapsulation. */
    index?: number;
}
export declare const Textarea: FC<PropsWithChildren<TextareaProps>>;
